<?php
namespace backend\models\searches;

use backend\models\DepositApi;
use common\helpers\ExcelHelper;
use common\helpers\UserAgentHelper;
use Yii;
use yii\data\ArrayDataProvider;
use yii\data\Pagination;
use yii\helpers\Url;

class DepositSearch extends DataTable
{
    public $sTime;
    public $eTime;
    public $name;
    public $type;

    /**
     * @inheritdoc
     */
    public function rules()
    {
        $rules = parent::rules();
        $rules[] = [['sTime', 'eTime', 'name', 'type'], 'safe'];
        return $rules;
    }

    /**
     * @param array $params
     * @param null|string $from
     * @return ArrayDataProvider
     */
    public function search($params, $from = null)
    {
        $this->setAttributes($params);
        // 初始化DataTable查询参数
        $this->initSearchParams();

        $pagination = new Pagination();
        $pagination->setPageSize($this->pageSize);
        $data['pageSize'] = $pagination->getPageSize();
        $data['page'] = $this->page;
        if ($this->orderBy) {
            $data['orderBy'] = $this->orderBy;
        }
        if (!empty($this->search['value']) && trim($this->search['value']) !== '') {
            $data['search'] = trim($this->search['value']);
        }
        if ($from == 'admin') {
            $data['from'] = $from;
            if ($this->sTime && ($inTimeStart = strtotime($this->sTime))) {
                $data['inTimeStart'] = $inTimeStart * 1000;
            }
            if ($this->eTime && ($inTimeEnd = strtotime($this->eTime))) {
                $data['inTimeEnd'] = $inTimeEnd * 1000;
            }
            $this->name && $data['name'] = $this->name;
            is_numeric($this->type) && $data['type'] = $this->type;
        } else {
            $data['memberId'] = Yii::$app->getUser()->getId();
        }

        if ($this->pageSize > 5000) {
            if (Yii::$app->getRequest()->getIsAjax()) {
                Yii::$app->getResponse()->redirect(Url::current(), UserAgentHelper::isIE() ? 200 : 302);
            } else {
                $this->exportXls($data);
            }
            Yii::$app->end();
        }

        $api = new DepositApi();
        $result = $api->getDepositList($data);
        $models = [];
        if ($result['code'] == 1) {
            $models = (array)$result['data']['dataList'];
            $pagination->totalCount = $result['data']['totalCount'];
        }
        $dataProvider = new ArrayDataProvider([
            'models' => $models,
            'pagination' => $pagination,
            'totalCount' => $pagination->totalCount,
        ]);
        return $dataProvider;
    }

    /**
     * @param array $data
     */
    private function exportXls($data)
    {
        ExcelHelper::init(); 
        $attachmentName = "入金管理_" . date('Y-m-d') . '.xlsx';
        $header = ['交易编号', '状态', '代理商', '账户', '姓名', '手机', '金额', '人民币', '汇率', '入金方式', '入金时间', '操作人'];
        $source = [];
        $api = new DepositApi();
        $data['pageSize'] = 5000;
        $data['page'] = 1;
        while (true) {
            $result = $api->getDepositList($data);
            if ($result['code'] == 1 && !empty($result['data']['dataList'])) {
                foreach ((array)$result['data']['dataList'] as $key => $row) {
                    $arr = [];
                    $arr[] = "SN{$row['id']}";
                    if ($row['type'] == 1) {
                        $arr[] = "成功";
                    } else {
                        $arr[] = "等待";
                    }
                    $arr[] = $row['IBNAME'];
                    $arr[] = $row['login'];
                    $arr[] = $row['name'];
                    $arr[] = $row['mobile'];
                    $arr[] = $row['amount'];
                    $arr[] = $row['rmb'];
                    $arr[] = $row['rate'];
                    $arr[] = $row['pay_name'];
                    $arr[] = date('Y-m-d H:i:s', intval($row['in_time'] / 1000));
                    $arr[] = $row['admin_name'];
                    $source[] = $arr;
                }
            } else {
                break;
            }
            if ($data['page'] * $data['pageSize'] >= $result['data']['totalCount']) {
                break;
            }
            $data['page']++;
        }
        ExcelHelper::output($source, $header, $attachmentName);
    }
}